/* ADC driver for A20 SoC
 *
 * Copyright (c) 2013 Grandstream Networks, Inc.
 * By Fanan Chen <fnchen@grandstream.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option)any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __SUNXI_ADC_H_
#define __SUNXI_ADC_H_

struct sunxi_adc_client {
	struct list_head list;
	struct platform_device *pdev;
	unsigned char channel;
	unsigned int conv_val;
	void (*convert_cb)(struct sunxi_adc_client *client);
	unsigned int debouce;
	unsigned int dcount;
};


extern struct sunxi_adc_client *sunxi_adc_client_register(
		struct platform_device *pdev,
		void (*convert_cb)(struct sunxi_adc_client *client),
		unsigned char channel, unsigned int debouce);

extern void sunxi_adc_client_unregister(struct sunxi_adc_client *client);
#endif
