#ifndef _SUN7I_USER_DMA_H
#define _SUN7I_USER_DMA_H
#include <linux/mm.h>

//#define USER_DMA_DEBUG
#if defined USER_DMA_DEBUG
	#define user_dma_dbg(fmt, args...) printk(fmt, ##args)
#else
	#define user_dma_dbg(fmt, args...)
#endif

struct user_dma_info
{
    int vir_channel;
    char name[64];
    int type;
    unsigned int src_virt;
    unsigned int dst_virt;
    unsigned int src_phy;
    unsigned int dst_phy;
    unsigned int len;
    unsigned int hdl;
    int status;
};

//we only support two pages
struct user_dma_info_ext
{
    int vir_channel;
    char name[64];
    int type;
    unsigned int src_virt;
    unsigned int dst_virt;
    unsigned int src_phy[2];
    unsigned int dst_phy[2];
    unsigned int len;
    unsigned int hdl;
    int status;
};

#define USER_DMA_START	_IOW('d', 0x01, struct user_dma_info)
#define USER_DMA_REQUEST	_IOWR('d', 0x02, struct user_dma_info)
#define USER_DMA_STOP	_IOW('d', 0x03, struct user_dma_info)
#endif
