
#include <common.h>
#include <asm/arch/android_misc.h>
#include <command.h>

int read_boot_from_nand(char* part, unsigned long ramaddr, unsigned long length)
{
	int ret = 0;
	char* boot_base =  (char*)ramaddr; 

	if (strncmp(part, "boot0", 5) == 0)
	{
		ret = NAND_ReadBoot0(length, boot_base);
	}
	else if (strncmp(part, "boot1", 5) == 0)
	{
		ret = NAND_ReadBoot1(length, boot_base);
	}

	return ret;
}

int write_boot_to_nand(char* part, unsigned long ramaddr, unsigned long length)
{
	int ret = 0;
	char* boot_base =  (char*)ramaddr; 
	
	if (strncmp(part, "boot0", 5) == 0)
	{
		ret = NAND_BurnBoot0(length, boot_base);
	}
	else if (strncmp(part, "boot1", 5) == 0)
	{
		ret = NAND_BurnBoot1(length, boot_base);
	}

	return ret;
}

