/*
**********************************************************************************************************************
*                                                    ePDK
*                                    the Easy Portable/Player Develop Kits
*                                              eBIOS Sub-System
*
*                                   (c) Copyright 2007-2009, Steven.ZGJ.China
*                                             All Rights Reserved
*
* Moudle  : iis bios module
* File    : iisc_private.h
*
* By      : Steven
* Version : v1.00
* Date    : 2008-8-19 18:38:16
**********************************************************************************************************************
*/
#ifndef _SW_IIC_H_
#define _SW_IIC_H_

#define REGS_BASE	   0x01C00000		//Ĵַ

#define TWIC0_REGS_BASE        ( REGS_BASE + 0x2AC00 )    //twi0
#define TWIC1_REGS_BASE        ( REGS_BASE + 0x2B000 )    //twi1
#define TWIC2_REGS_BASE        ( REGS_BASE + 0x2B400 )    //twi2

#define CFG_SW_IIC_MAX      4
#define CFG_SW_IIC_CTL0	   TWIC0_REGS_BASE	      /* iic0 */
#define CFG_SW_IIC_CTL1	   TWIC1_REGS_BASE	      /* iic1 */
#define CFG_SW_IIC_CTL2	   TWIC2_REGS_BASE	      /* iic2 */

#define __REG(x)    (*(volatile unsigned int   *)(x))
#define __REGw(x)   (*(volatile unsigned int   *)(x))
#define __REGhw(x)  (*(volatile unsigned short *)(x))
#define __REGb(x)   (*(volatile unsigned char  *)(x))

#define CCMU_REG_o_APB1					0x58
#define CCMU_REG_o_AXI_MOD				0x5C
#define CCMU_REG_o_AHB_MOD0				0x60
#define CCMU_REG_o_AHB_MOD1				0x64
#define CCMU_REG_o_APB_MOD0				0x68
#define CCMU_REG_o_APB_MOD1				0x6C

#define CCMU_REGS_BASE         ( REGS_BASE + 0x20000 )    //clock manager unit
#define INTC_REGS_BASE          ( REGS_BASE + 0x20400 )    //arm interrupt controller
#define CCMU_REG_APB_MOD1    __REG( CCMU_REGS_BASE + CCMU_REG_o_APB_MOD1)
#define CCMU_REG_APB1		    __REG( CCMU_REGS_BASE + CCMU_REG_o_APB1)

#define SW_IIC_READ        (1)
#define SW_IIC_WRITE       (0)

struct sw_iic
{
    volatile unsigned int addr;        /* slave address     */
    volatile unsigned int xaddr;       /* extend address    */
    volatile unsigned int data;        /* data              */
    volatile unsigned int ctl;         /* control           */
    volatile unsigned int status;      /* status            */
    volatile unsigned int clk;         /* clock             */
    volatile unsigned int srst;        /* soft reset        */
    volatile unsigned int eft;         /* enhanced future   */
};

typedef struct  _twi_arg
{
    __u32    slave_addr;             //豸ַ
    __u32    slave_addr_flag;        //õַ  07bit 110bit
	__u8    *byte_addr;              //Ҫдڴ豸еĵַ
	__u32    byte_addr_width;        //õַ  018 bit; ִֽ
	__u32    byte_count;             //һζдҪɵֽ
	__u32    if_restart;             //ǷҪrestart
	__u8    *data;                   //ݵĵַ
}_twi_arg_t;


typedef volatile struct sw_iic *sw_iic_t;

enum  _sw_iic_operation_status
{
    SW_IIC_OPERATION_NO_ERR         = 0,
    SW_IIC_OPERATION_START_NO_INT   = -1

};

__s32 eGon2_twi_init(__s32 twi_port, void *twi_ctrl, __u32 system_clock, __u32 twi_run_clock);
	
#endif /* _SW_IIC_H_ */

/*end of sw_iic.h*/
