#include <net.h>
#include "sun7i_gmac_base.h"
extern void gs_gmac_rx_desc_init_ring(dma_desc *desc, unsigned int last_ring_desc);
extern void gs_gmac_tx_desc_init_ring(dma_desc *desc, unsigned int last_ring_desc);
extern s32 gs_gmac_set_rx_qptr(gs_gmac_device *gmacdev, u32 Buffer1, u32 Length1, u32 Data1, u32 Buffer2, u32 Length2, u32 Data2);
extern void gmac_clk_ctl(unsigned int flag);
extern void gmac_mdio_reset(void);
extern int gmac_mdio_init(void);
extern s32 gs_gmac_scan_phy(gs_gmac_device *gmacdev);
extern s32 gs_gmac_write_phy_reg(u32 RegBase, u32 Phy_addr, u32 reg, u16 data);
extern s32 gs_gmac_check_phy_init(gs_gmac_device *gmacdev);
extern s32 gs_gmac_dma_bus_mode_init(void);
extern void gs_gmac_init_tx_desc_base(gs_gmac_device *gmacdev);
extern void gs_gmac_init_rx_desc_base(gs_gmac_device *gmacdev);
extern void core_init(void);
extern void gs_gmac_dma_operation_mode(void);
extern void gs_gmac_tx_enable(gs_gmac_device *gmacdev);
extern void gs_gmac_rx_enable(gs_gmac_device *gmacdev);
extern void gs_gmac_clear_interrupt(gs_gmac_device *gmacdev);
extern void gs_gmac_enable_interrupt(gs_gmac_device *gmacdev, u32 interrupts);
extern void gs_gmac_enable_dma_rx(gs_gmac_device *gmacdev);
extern void gs_gmac_enable_dma_tx(gs_gmac_device *gmacdev);
extern s32 gs_gmac_set_mac_addr(gs_gmac_device *gmacdev, u32 MacHigh, u32 MacLow, u8 *MacAddr);
extern s32 gs_gmac_set_tx_qptr(gs_gmac_device *gmacdev, u32 Buffer1, u32 Length1, u32 Data1, u32 Buffer2, u32 Length2, u32 Data2,u32 offload_needed);
extern void gs_gmac_resume_dma_tx(gs_gmac_device *gmacdev);
extern int gs_gmac_intr_tx_handler(gs_gmac_device *gmacdev);
extern u32 gs_gmac_read_reg(u32 RegBase, u32 RegOffset);
extern u32 gs_gmac_get_interrupt_type(gs_gmac_device *gmacdev, u32 clear_mask);
extern void gs_handle_received_data(gs_gmac_device *gmacdev);
extern void gs_gmac_resume_dma_rx(gs_gmac_device *gmacdev);
extern void gs_gmac_tx_disable(gs_gmac_device *gmacdev);
extern void gs_gmac_rx_disable(gs_gmac_device *gmacdev);
extern void gs_gmac_disable_dma_tx(gs_gmac_device *gmacdev);
extern void gs_gmac_disable_dma_rx(gs_gmac_device *gmacdev);
extern int gmac_system_init(void);
extern s32 gs_gmac_reset(gs_gmac_device *gmacdev);
extern s32 gs_gmac_attach(gs_gmac_device *gmacdev, u32 macBase, u32 dmaBase);

#define to_gmac(_nd) container_of(_nd, struct gsGMACDeviceStruct, netdev)
#define RX_BUFFER_LEN 2048
#define DEFAULT_MAC_ADDRESS {0x00, 0x55, 0x7B, 0xB5, 0x7D, 0xF7}
#define TRANSMIT_DESC_SIZE  256	//Tx Descriptors needed in the Descriptor pool/queue
#define RECEIVE_DESC_SIZE   256	//Rx Descriptors needed in the Descriptor pool/queue
#define MACG_TX_TIMEOUT 10
#define DEFAULT_LOOP_VARIABLE   50000
